#pragma once
#include "resource.h"
#include "launch/launch.h"

#define APP_TITLE	"mini ISD"
#define WM_NOTIFY_ICON	(WM_APP + 100)
#define SC_ABOUT	100
#define SIG_COPYDATA	"mISD" /* WM_COPYDATÃVOl` */

/****************************************************************************
 *	CFileList
 ****************************************************************************/

class CFileList : public CListBox {
public:
	int refresh();
	//{{AFX_VIRTUAL(CFileList)
	protected:
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CFileList)
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnDblclk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/****************************************************************************
 *	CMyDlg
 ****************************************************************************/

class CMyDlg : public CDialog {
public:
	CMyDlg(CWnd* pParent = NULL);
	//{{AFX_DATA(CMyDlg)
	enum { IDD = IDD_MINISD };
	CFileList m_filelist;
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CMyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual void OnOK();
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;
	NOTIFYICONDATA m_nid;
	//{{AFX_MSG(CMyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnDestroy();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	//}}AFX_MSG
	afx_msg void OnNotifyIcon(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/****************************************************************************
 *	CMyApp
 ****************************************************************************/

class CMyApp : public CWinApp {
public:
	//{{AFX_VIRTUAL(CMyApp)
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CMyApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/****************************************************************************
 *	CMyOleDropSource
 ****************************************************************************/

/* hbvOɃ[h邽߂̃tbNB
 * x̐`łɂAxDrag&Dropɂ̂ݎg܂B
 * xȏgƐ삵܂BӁI
 */
class CMyOleDropSource : public COleDropSource {
public:
	CMyOleDropSource();
	virtual ~CMyOleDropSource();
	virtual SCODE QueryContinueDrag(BOOL bEscapePressed, DWORD dwKeyState);
	CStringList fname_list;		/* [ht@CXg */
	/* QueryContinueDrag̒ŃG[_CAO\ƁA
	 * hbOȂ̂Ń}EXLv`ĂāA[OK]ȂȂ܂B
	 * āADoDragDropIɃG[bZ[W\悤ɁA
	 * G[̓bZ[WɊi[Ă܂B
	 */
	CString err_msg;
protected:
	CStringList fname_list_loaded;	/* [ht@CXg */
};

/****************************************************************************
 *	̑
 ****************************************************************************/

void write_files(CStringList* fname_list);
void split_cmdline(const char* p, CStringList* list);
void run_pex(const char* fname);
void run_srf(char* data);
